## flightgear 3.0.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6.4)

include (CheckFunctionExists)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckIncludeFile)

project(FlightGear)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

if(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # use official include provided by latest CMake
    include(GNUInstallDirs)
else(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # backward compatibility: use our own module for older cmake versions
    include(OldGNUInstallDirs)
endif(${CMAKE_VERSION} VERSION_GREATER 2.8.4)

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'fgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../fgbuild && cd ../fgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)

# System detection/default settings
include( DetectDistro )
include( DetectBrowser )

set(CMAKE_DEBUG_POSTFIX          "d" CACHE STRING "add a postfix, usually d on windows")
set(CMAKE_RELEASE_POSTFIX        ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX     ""  CACHE STRING "add a postfix, usually empty on windows")

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ version versionFile)
if (NOT versionFile)
    message(FATAL_ERROR "Unable to determine FlightGear version. Version file is missing.")
endif()
string(STRIP "${versionFile}" FLIGHTGEAR_VERSION)

# FlightGear packaging (to build a source tarball)
include( ConfigureCPack )

# FlightGear base package path
if (FG_DATA_DIR)
    message(STATUS "Using explicit data directory for base package: ${FG_DATA_DIR}")
else()
    set(FG_DATA_DIR "${CMAKE_INSTALL_PREFIX}/lib/FlightGear" CACHE PATH "Default location where data files are located")
    message(STATUS "Using default data directory for base package:  ${FG_DATA_DIR}")
endif()

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(NOT "$ENV{BUILD_ID}" STREQUAL "")
    set(HUDSON_BUILD_ID $ENV{BUILD_ID})
    set(HUDSON_BUILD_NUMBER $ENV{BUILD_NUMBER})
    message(STATUS "running under Hudson/Jenkins, build-number is ${HUDSON_BUILD_NUMBER}")
else()
    set(HUDSON_BUILD_NUMBER 0)
    set(HUDSON_BUILD_ID "none")
endif()

#####################################################################################
# Configure library search paths
#####################################################################################

if(APPLE)
    # Custom library directories for Mac, which should have precedence over any other
    list(APPEND ADDITIONAL_LIBRARY_PATHS
         ~/Library/Frameworks
         /Library/Frameworks)
endif(APPLE)

if(NOT "${CMAKE_LIBRARY_ARCHITECTURE}" STREQUAL "")
    # Workaround for Ubuntu/Debian which introduced the "multiarch" library
    # directory structure, which is unsupported by CMake < 2.8.10, so we need to
    # add paths manually
    # see http://www.cmake.org/Bug/view.php?id=12049 and
    # http://www.cmake.org/Bug/view.php?id=12037
    list(APPEND ADDITIONAL_LIBRARY_PATHS
         /usr/local/lib/${CMAKE_LIBRARY_ARCHITECTURE}
         /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}
         /lib/${CMAKE_LIBRARY_ARCHITECTURE})
    message(STATUS "additional library directories: ${ADDITIONAL_LIBRARY_PATHS}")
endif()

if(NOT MSVC)
    # TBD: are these really necessary? Aren't they considered by cmake automatically?
    list(APPEND ADDITIONAL_LIBRARY_PATHS
         /opt/local
         /usr/local
         /usr)
endif()
#####################################################################################

IF(APPLE)
    set(EVENT_INPUT_DEFAULT 1)

    find_library(CORESERVICES_LIBRARY CoreServices)
    find_library(COCOA_LIBRARY Cocoa)
    list(APPEND PLATFORM_LIBS ${COCOA_LIBRARY} ${CORESERVICES_LIBRARY})

elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(USE_DBUS_DEFAULT 1)
    find_package(UDev)

    if(UDEV_FOUND)
        set(EVENT_INPUT_DEFAULT 1)
    endif(UDEV_FOUND)
endif()

find_package(Git)
if (GIT_FOUND)
    execute_process(COMMAND git --git-dir ${PROJECT_SOURCE_DIR}/.git rev-parse  HEAD
        OUTPUT_VARIABLE REVISION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Git revision is ${REVISION}")
else()
    set(REVISION "none")
endif()

# FlightGear build options
option(SIMGEAR_SHARED    "Set to ON when SimGear was built as a shared library" OFF)
option(LOGGING           "Set to ON to build FlightGear with logging support (default)" ON)
option(SP_FDMS           "Set to ON to build FlightGear with special-purpose FDMs" OFF)
option(ENABLE_UIUC_MODEL "Set to ON to build FlightGear with UIUCModel FDM" OFF)
option(ENABLE_LARCSIM    "Set to ON to build FlightGear with LaRCsim FDM" OFF)
option(ENABLE_YASIM      "Set to ON to build FlightGear with YASIM FDM (default)" ON)
option(ENABLE_JSBSIM     "Set to ON to build FlightGear with JSBSim FDM (default)" ON)
option(EVENT_INPUT       "Set to ON to build FlightGear with event-based Input support" ${EVENT_INPUT_DEFAULT})
option(ENABLE_RTI        "Set to ON to build FlightGear with RTI support" OFF)
option(ENABLE_PROFILE    "Set to ON to build FlightGear with gperftools profiling support" OFF)
option(JPEG_FACTORY      "Set to ON to build FlightGear with JPEG-factory support" OFF)
option(SYSTEM_SQLITE     "Set to ON to build FlightGear with the system's SQLite3 library" OFF)
option(ENABLE_IAX        "Set to ON to build FlightGear with IAXClient/fgcom built-in (default)" ON)
option(USE_DBUS          "Set to ON to build FlightGear with DBus screensaver interaction (default on Linux)" ${USE_DBUS_DEFAULT})

# additional utilities
option(ENABLE_FGADMIN    "Set to ON to build the FGADMIN application (default)" ON)
option(ENABLE_FGELEV     "Set to ON to build the fgelev application (default)" ON)
option(WITH_FGPANEL      "Set to ON to build the fgpanel application (default)" ON)
option(ENABLE_FGVIEWER   "Set to ON to build the fgviewer application (default)" ON)
option(ENABLE_GPSSMOOTH  "Set to ON to build the GPSsmooth application (default)" ON)
option(ENABLE_TERRASYNC  "Set to ON to build the terrasync application (default)" ON)
option(ENABLE_FGJS       "Set to ON to build the fgjs application (default)" ON)
option(ENABLE_JS_DEMO    "Set to ON to build the js_demo application (default)" ON)
option(ENABLE_METAR      "Set to ON to build the metar application (default)" ON)
option(ENABLE_TESTS      "Set to ON to build test applications (default)" ON)
option(ENABLE_FGCOM      "Set to ON to build the FGCom application (default)" ON)

if(LOGGING)
    # nothing
else()
    set(FG_NDEBUG 1)
endif()

if(SP_FDMS)
    set(ENABLE_SP_FDM 1)
endif()

if(ENABLE_FGCOM)
  set(ENABLE_IAX 1)
endif()

# Setup MSVC 3rd party directories
include( ConfigureMsvc3rdParty )

if(EVENT_INPUT)
    if(APPLE)
    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
        if(NOT UDEV_FOUND)
            message(WARNING "UDev not found, event input is disabled!")
            set(EVENT_INPUT 0)
        else()
            add_definitions(-DWITH_EVENTINPUT)
            set(EVENT_INPUT_LIBRARIES ${UDEV_LIBRARIES})
            message(STATUS "event-based input enabled. Using ${UDEV_LIBRARIES}")
        endif()
    else()
        message(WARNING "event-based input is not supported on this platform yet")
    endif()

    # Keep PLIB INPUT enabled as long as EventInput does not replace current joystick configurations.
    set(ENABLE_PLIB_JOYSTICK 1)
else(EVENT_INPUT)
    set(ENABLE_PLIB_JOYSTICK 1)
endif(EVENT_INPUT)

# check required dependencies
find_package(Boost   REQUIRED)
find_package(ZLIB    REQUIRED)
find_package(Threads REQUIRED)
find_package(OpenGL  REQUIRED)
find_package(OpenAL  REQUIRED)
find_package(OpenSceneGraph 3.0.0 REQUIRED osgText osgSim osgDB osgParticle osgFX osgUtil osgViewer osgGA)

if (MSVC)
	find_package(CrashRpt)
	if (CRASHRPT_FOUND)
		set(HAVE_CRASHRPT 1)
		message(STATUS "Using CrashRpt")
        include_directories( ${CRASHRPT_INCLUDE_DIR})
	endif()
endif()

if(ENABLE_FGADMIN)
    find_package(FLTK)

    if ( FLTK_FOUND )
        if ( X11_Xinerama_FOUND )
            message(STATUS "Found X11_Xinerama...")
            list(APPEND FLTK_LIBRARIES ${X11_Xinerama_LIB})
        endif()

        if ( X11_Xft_FOUND )
            message(STATUS "Found X11_Xft...")
            list(APPEND FLTK_LIBRARIES ${X11_Xft_LIB})
        endif()

        if ( CMAKE_DL_LIBS )
            list(APPEND FLTK_LIBRARIES ${CMAKE_DL_LIBS})
        endif()

        message(STATUS "Using FLTK_LIBRARIES for fgadmin: ${FLTK_LIBRARIES}")
    endif ( FLTK_FOUND )
endif(ENABLE_FGADMIN)

##############################################################################
## Sqlite3 setup

if (SYSTEM_SQLITE)
    find_package(SQLite3 REQUIRED)
    
    message(STATUS "Using system SQLite3 library")
else()
    set(SQLITE3_INCLUDED_DIR "${CMAKE_SOURCE_DIR}/3rdparty/sqlite3")
    # this target is defined in src/Navaids/CMakeLists.txt
    list(APPEND SQLITE3_LIBRARY fgsqlite3)
endif (SYSTEM_SQLITE)

# Sqlite always depends on the threading lib
list(APPEND SQLITE3_LIBRARY ${CMAKE_THREAD_LIBS_INIT})

##############################################################################
## DBus setup

if (USE_DBUS)
    include(FindPkgConfig)
    if (PKG_CONFIG_FOUND)
        pkg_check_modules(DBUS dbus-1)
    endif (PKG_CONFIG_FOUND) #if we don't have pkg-config, assume we don't have libdbus-1-dev either http://packages.debian.org/sid/libdbus-1-dev
    if (DBUS_FOUND)
        set(HAVE_DBUS 1)
        message(STATUS "Using DBus")
        include_directories( ${DBUS_INCLUDE_DIRS})
    else()
        message(STATUS "DBus not found, screensaver control disabled")
    endif (DBUS_FOUND)
else()
endif (USE_DBUS)

# Sqlite always depends on the threading lib
list(APPEND SQLITE3_LIBRARY ${CMAKE_THREAD_LIBS_INIT})

##############################################################################

find_package(PLIB REQUIRED puaux pu js fnt)

# FlightGear and SimGear versions need to match
find_package(SimGear ${FLIGHTGEAR_VERSION} REQUIRED)

##############################################################################

if (JPEG_FACTORY)
    # check simgear was built with JPEG-factory support
    find_package(JPEG REQUIRED)
    include_directories(${JPEG_INCLUDE_DIR})

    set(CMAKE_REQUIRED_INCLUDES
        ${SIMGEAR_INCLUDE_DIR}
        ${JPEG_INCLUDE_DIR}
        ${OPENSCENEGRAPH_INCLUDE_DIRS})

    check_cxx_source_compiles(
        "#include <simgear/screen/jpgfactory.hxx>
        int main()    { return 0; } "
        FG_JPEG_SERVER)

    if (NOT FG_JPEG_SERVER)
        message(STATUS "JPEG server support requested, but SimGear was built without JPEG support")
    endif()
endif()

check_include_file(unistd.h   HAVE_UNISTD_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(windows.h  HAVE_WINDOWS_H)

if(ENABLE_PROFILE)
    find_package(GooglePerfTools REQUIRED)
    set(FG_HAVE_GPERFTOOLS 1)
    message(STATUS "Built-in profiler using gperftools available")
endif()

if(ENABLE_RTI)
    message(STATUS "RTI: ENABLED")
    find_package(RTI)
    if(RTI_FOUND)
        set(FG_HAVE_HLA 1)
    endif(RTI_FOUND)
else()
    message(STATUS "RTI: DISABLED")
endif(ENABLE_RTI)

if(CMAKE_COMPILER_IS_GNUCXX)
    set(WARNING_FLAGS_CXX "-Wall")
    set(WARNING_FLAGS_C   "-Wall")
endif(CMAKE_COMPILER_IS_GNUCXX)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang") 
   set (WARNING_FLAGS_CXX "-Wall -Wno-overloaded-virtual")
   set (WARNING_FLAGS_C   "-Wall")

=== 3rdparty/CMakeLists.txt ===

if (NOT SYSTEM_SQLITE)
    add_subdirectory(sqlite3)
endif()

if (ENABLE_IAX)
    add_subdirectory(iaxclient/lib)
endif()

=== man/CMakeLists.txt ===
if (MSVC)
    # don't install man pages on Windows
else(MSVC)

if(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # use official include provided by latest CMake
    include(GNUInstallDirs)
else(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # backward compatibility: use our own module for older cmake versions
    include(OldGNUInstallDirs)
endif(${CMAKE_VERSION} VERSION_GREATER 2.8.4)

set(MANPAGES
    fgfs.1
)

if(WITH_FGPANEL)
    list(APPEND MANPAGES fgpanel.1)
endif()

if(ENABLE_TERRASYNC)
    list(APPEND MANPAGES terrasync.1)
endif()

if(ENABLE_FGJS)
    list(APPEND MANPAGES fgjs.1)
endif()

if(ENABLE_JS_DEMO)
    list(APPEND MANPAGES js_demo.1)
endif()

# map some variables to what the man-pages expect
set(PACKAGE ${CMAKE_PROJECT_NAME})
set(VERSION ${FLIGHTGEAR_VERSION})

foreach(man ${MANPAGES})
    configure_file (
        "${PROJECT_SOURCE_DIR}/man/${man}.in"
        "${PROJECT_BINARY_DIR}/man/${man}"
        )

    install(FILES ${PROJECT_BINARY_DIR}/man/${man}
          DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
endforeach()

endif(MSVC)

=== src/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR})

# note order here affects link order, and hence linking correctness
# on systems with a traditional ld (eg, GNU ld on Linux)
foreach( mylibfolder 
		Airports
		Aircraft
		ATC
		ATCDCL
		Canvas
		Radio
		Autopilot
		Cockpit
		Environment
		GUI
		Input
		Instrumentation
		Model
		MultiPlayer
		AIModel
		Navaids
		Network
		Scenery
		Scripting
		Sound
		Systems
		Time
		Traffic
		FDM
		Viewer
		Main
	)

	add_subdirectory(${mylibfolder})

endforeach( mylibfolder )

=== utils/CMakeLists.txt ===
if(FLTK_FOUND)
    if (EXISTS ${FLTK_FLUID_EXECUTABLE})
        add_subdirectory(fgadmin)
    else ()
        message(STATUS "fluid executable not found, disabling fgadmin")
    endif ()
endif()

# win32 is just excluded because of not having argument parsing there ...
if(RTI_FOUND AND NOT WIN32)
      add_subdirectory(fgai)
endif()

if(ENABLE_FGELEV)
    add_subdirectory(fgelev)
endif()

if(WITH_FGPANEL)
      add_subdirectory(fgpanel)
endif()

if(ENABLE_FGVIEWER)
    add_subdirectory(fgviewer)
endif()

if(ENABLE_GPSSMOOTH)
    add_subdirectory(GPSsmooth)
endif()

if(ENABLE_TERRASYNC)
    add_subdirectory(TerraSync)
endif()

if(ENABLE_FGCOM)
    add_subdirectory(fgcom)
endif()

=== src/ATC/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	atc_mgr.cxx
	atcdialog.cxx
	trafficcontrol.cxx
	CommStation.cxx
	)

set(HEADERS
	atc_mgr.hxx
	atcdialog.hxx
	trafficcontrol.hxx
	CommStation.hxx
	)
    	
flightgear_component(ATC "${SOURCES}" "${HEADERS}")

=== src/ATCDCL/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	ATC.cxx
	atis.cxx
	ATCVoice.cxx
	ATISmgr.cxx
	ATCutils.cxx
	ATCProjection.cxx
	)

set(HEADERS
	ATC.hxx
	atis.hxx
	ATCVoice.hxx
	ATISmgr.hxx
	ATCutils.hxx
	ATCProjection.hxx
	atis_lexicon.hxx
	atis_remap.hxx
	)
    	
flightgear_component(ATCDCL "${SOURCES}" "${HEADERS}")

=== src/Aircraft/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	controls.cxx
	replay.cxx
	flightrecorder.cxx
    FlightHistory.cxx
	)

set(HEADERS
	controls.hxx
	replay.hxx
	flightrecorder.hxx
    FlightHistory.hxx
	)


flightgear_component(Aircraft "${SOURCES}" "${HEADERS}")

=== src/Airports/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	apt_loader.cxx
	dynamicloader.cxx
	dynamics.cxx
	gnnode.cxx
	groundnetwork.cxx
	parking.cxx
	pavement.cxx
	runwaybase.cxx
	runwayprefloader.cxx
	runwayprefs.cxx
	runways.cxx
	sidstar.cxx
	airport.cxx
	xmlloader.cxx
	)

set(HEADERS
    airports_fwd.hxx
	apt_loader.hxx
	dynamicloader.hxx
	dynamics.hxx
	gnnode.hxx
	groundnetwork.hxx
	parking.hxx
	pavement.hxx
	runwaybase.hxx
	runwayprefloader.hxx
	runwayprefs.hxx
	runways.hxx
	sidstar.hxx
	airport.hxx
	xmlloader.hxx
	)
    		
flightgear_component(Airports "${SOURCES}" "${HEADERS}")

=== src/Environment/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	atmosphere.cxx
	environment.cxx
	environment_ctrl.cxx
	environment_mgr.cxx
	ephemeris.cxx
	fgclouds.cxx
	fgmetar.cxx
	fgwind.cxx
	metarairportfilter.cxx
	metarproperties.cxx
	precipitation_mgr.cxx
	realwx_ctrl.cxx
	ridge_lift.cxx
	terrainsampler.cxx
	presets.cxx
	gravity.cxx
    magvarmanager.cxx
	)

set(HEADERS
	atmosphere.hxx
	environment.hxx
	environment_ctrl.hxx
	environment_mgr.hxx
	ephemeris.hxx
	fgclouds.hxx
	fgmetar.hxx
	fgwind.hxx
	metarairportfilter.hxx
	metarproperties.hxx
	precipitation_mgr.hxx
	realwx_ctrl.hxx
	ridge_lift.hxx
	terrainsampler.hxx
	presets.hxx
	gravity.hxx
    magvarmanager.hxx
	)
    		
flightgear_component(Environment "${SOURCES}" "${HEADERS}")

=== src/FDM/CMakeLists.txt ===
include(FlightGearComponent)

if(SP_FDMS)
set(SP_FDM_SOURCES
	SP/ACMS.cxx
	SP/ADA.cxx
	SP/Balloon.cxx
	SP/BalloonSim.cpp
	SP/MagicCarpet.cxx
	)
endif()

set(UIUC_SOURCES
	uiuc_1DdataFileReader.cpp
	uiuc_1Dinterpolation.cpp
	uiuc_2DdataFileReader.cpp
	uiuc_2Dinterpolation.cpp
	uiuc_3Dinterpolation.cpp
	uiuc_aerodeflections.cpp
	uiuc_alh_ap.cpp
	uiuc_auto_pilot.cpp
	uiuc_betaprobe.cpp
	uiuc_coef_drag.cpp
	uiuc_coef_lift.cpp
	uiuc_coef_pitch.cpp
	uiuc_coef_roll.cpp
	uiuc_coef_sideforce.cpp
	uiuc_coef_yaw.cpp
	uiuc_coefficients.cpp
	uiuc_controlInput.cpp
	uiuc_convert.cpp
	uiuc_engine.cpp
	uiuc_find_position.cpp
	uiuc_flapdata.cpp
	uiuc_fog.cpp
	uiuc_gear.cpp
	uiuc_get_flapper.cpp
	uiuc_getwind.cpp
	uiuc_hh_ap.cpp
	uiuc_ice.cpp
	uiuc_iceboot.cpp
	uiuc_iced_nonlin.cpp
	uiuc_icing_demo.cpp
	uiuc_initializemaps.cpp
	uiuc_map_CD.cpp
	uiuc_map_CL.cpp
	uiuc_map_CY.cpp
	uiuc_map_Cm.cpp
	uiuc_map_Cn.cpp
	uiuc_map_Croll.cpp
	uiuc_map_controlSurface.cpp
	uiuc_map_engine.cpp
	uiuc_map_fog.cpp
	uiuc_map_gear.cpp
	uiuc_map_geometry.cpp
	uiuc_map_ice.cpp
	uiuc_map_init.cpp
	uiuc_map_keyword.cpp
	uiuc_map_mass.cpp
	uiuc_map_misc.cpp
	uiuc_map_record1.cpp
	uiuc_map_record2.cpp
	uiuc_map_record3.cpp
	uiuc_map_record4.cpp
	uiuc_map_record5.cpp
	uiuc_map_record6.cpp
	uiuc_menu.cpp
	uiuc_menu_CD.cpp
	uiuc_menu_CL.cpp
	uiuc_menu_CY.cpp
	uiuc_menu_Cm.cpp
	uiuc_menu_Cn.cpp
	uiuc_menu_Croll.cpp
	uiuc_menu_controlSurface.cpp
	uiuc_menu_engine.cpp
	uiuc_menu_fog.cpp
	uiuc_menu_functions.cpp
	uiuc_menu_gear.cpp
	uiuc_menu_geometry.cpp
	uiuc_menu_ice.cpp
	uiuc_menu_init.cpp
	uiuc_menu_mass.cpp
	uiuc_menu_misc.cpp
	uiuc_menu_record.cpp
	uiuc_pah_ap.cpp
	uiuc_parsefile.cpp
	uiuc_rah_ap.cpp
	uiuc_recorder.cpp
	uiuc_warnings_errors.cpp
	uiuc_wrapper.cpp
	)
	
set(LARCSIM_SOURCES
    atmos_62.c
    basic_aero.c
    basic_engine.c
    basic_gear.c
    basic_init.c
    c172_aero.c
    c172_engine.c
    c172_gear.c
    c172_init.c
    cherokee_aero.c
    cherokee_engine.c
    cherokee_gear.c
    cherokee_init.c
    default_model_routines.c
    ls_accel.c
    ls_aux.c
    ls_geodesy.c
    ls_gravity.c
    ls_init.c
    ls_interface.c
    ls_matrix.c
    ls_model.c
    ls_step.c
    navion_aero.c
    navion_engine.c
    navion_gear.c
    navion_init.c
    uiuc_aero.c
    IO360.cxx
    LaRCsim.cxx
    LaRCsimIC.cxx
    )
	
set(SOURCES
	NullFDM.cxx
	UFO.cxx
	fdm_shell.cxx
	flight.cxx
	flightProperties.cxx
	TankProperties.cxx
	groundcache.cxx
	${SP_FDM_SOURCES}
	ExternalNet/ExternalNet.cxx
	ExternalPipe/ExternalPipe.cxx
	)

if(ENABLE_UIUC_MODEL)
	foreach(component ${UIUC_SOURCES})
		list(APPEND SOURCES "UIUCModel/${component}")
	endforeach()
endif()

if(ENABLE_LARCSIM)
	foreach(component ${LARCSIM_SOURCES})
		list(APPEND SOURCES "LaRCsim/${component}")
	endforeach()
endif()

flightgear_component(FDM "${SOURCES}")

if(ENABLE_YASIM)
	add_subdirectory(YASim)
endif()


if(ENABLE_JSBSIM)
    add_subdirectory(JSBSim)
    
    # FIXME - push this down once JSBSim doesn't expose private headers
    include_directories(${PROJECT_SOURCE_DIR}/src/FDM/JSBSim)
endif()

=== src/GUI/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	AirportList.cxx
	CanvasWidget.cxx
	MapWidget.cxx
	WaypointList.cxx
	dialog.cxx
	FGPUIDialog.cxx
	fonts.cxx
	gui.cxx
	gui_funcs.cxx
	layout-props.cxx
	layout.cxx
	menubar.cxx
	FGPUIMenuBar.cxx
	new_gui.cxx
	property_list.cxx
	FGFontCache.cxx
	FGColor.cxx
    FileDialog.cxx
    PUIFileDialog.cxx
    MouseCursor.cxx
    MessageBox.cxx
	)

set(HEADERS
	AirportList.hxx
	CanvasWidget.hxx
	MapWidget.hxx
	WaypointList.hxx
	dialog.hxx
	FGPUIDialog.hxx
	gui.h
	layout.hxx
	menubar.hxx
	FGPUIMenuBar.hxx
	new_gui.hxx
	property_list.hxx
	FGFontCache.hxx
	FGColor.hxx
    FileDialog.hxx
    PUIFileDialog.hxx
    MouseCursor.hxx
    MessageBox.hxx
	)

if(WIN32)
	message(STATUS "on Windows")

	list(APPEND HEADERS WindowsMouseCursor.hxx)
	list(APPEND SOURCES WindowsMouseCursor.cxx)
endif()
		
if (APPLE)
    list(APPEND HEADERS FGCocoaMenuBar.hxx 
        CocoaFileDialog.hxx 
        CocoaMouseCursor.hxx
        CocoaHelpers.h
        CocoaHelpers_private.h)
    list(APPEND SOURCES FGCocoaMenuBar.mm 
        CocoaFileDialog.mm
        CocoaMouseCursor.mm
        CocoaHelpers.mm)
endif()
    		
flightgear_component(GUI "${SOURCES}" "${HEADERS}")

=== debian/changelog ===
flightgear (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Adjust watchfile to account for release candidates.
  * Adjust dependencies to require at least 3.0.0 of simgear and
    flightgear-data packages.
  * Move fgcom data to /usr/share/games/flightgear.
  * Correct doc-base registration of additional HTML documents.
  * Link against system-provided libgsm and libspeex.

 -- Markus Wanner <markus@bluegap.ch>  Wed, 19 Feb 2014 08:23:38 -0800

flightgear (3.0.0~git20140204+c99ea4-1) unstable; urgency=low

  [ Markus Wanner ]
  * Upload to unstable.
  * Adjust B-D to allow building on kfreebsd-*. Closes: #724686.
  * Add a lintian-overrides on autotools; we use cmake.
  * Upstream corrected the fgfs manpage. Closes: #556362.
  * Drop unnecessary man page for gl-info. Closes: #698308.
  * Drop README.Linux: it's outdated to the point of uselessness.
    Closes: #574173.
  * Add an upper limit of libsimgear-dev versions that flightgear can be
    built with. Closes: #738436.
  * Drop the libsvn-dev dependency, neither flightgear nor simgear depend
    on libsvn, anymore. Closes: #682947.
  * List icons in debian/install rather than copying around from rules.
  * Update menu entry for flightgear, add one for fgcom; add .xpm icons.
    Closes: #713924.
  * flightgear.desktop: add German translation
  * Bump Standards-Version to 3.9.5; no changes needed.

  [ Rebecca Palmer ]
  * New upstream release.
  * Install the icons (based on code by Saikrishna Arcot).  (Not a
    complete fix for LP908153 as it only sets the menu/Dash icon, not the
    running window's icon, but better than nothing).
  * Disable screensaver while running. Closes: LP#793599. Add required
    libdbus-1-dev dependency.
  * Remove outdated README.Debian.
  * Terrasync now works after just ticking the box. Closes: #252899.
  * Always set Terrasync directory.

 -- Markus Wanner <markus@bluegap.ch>  Tue, 21 Jan 2014 22:31:02 +0100

flightgear (2.12.0-1) experimental; urgency=low

  * New upstream release. Closes: #723976, #487388.
  * Adjust dependencies on simgear and flightgear-data for 2.12.
  * Drop patches terrasync.patch, CVE-2012-2090.diff, CVE-2013-2091.diff,
    and bug1117.diff. These got applied upstream.

 -- Markus Wanner <markus@bluegap.ch>  Mon, 23 Sep 2013 22:20:15 +0200

flightgear (2.10.0-4) unstable; urgency=low

  * Accept libopenscenegraph-3.2.0~rc1, again, as per discussion with OSG
    maintainers. Recompile against that version. Closes: #722193.

 -- Markus Wanner <markus@bluegap.ch>  Fri, 20 Sep 2013 20:18:15 +0200

flightgear (2.10.0-3) unstable; urgency=low

  * Mark libopenscenegraph-3.2.0~rc1 as breaking simgear: it uses a
    library major version different from the final 3.2.0 series.
    Closes: #722193.

 -- Markus Wanner <markus@bluegap.ch>  Fri, 13 Sep 2013 20:56:14 +0200

flightgear (2.10.0-3) UNRELEASED; urgency=low

  * Mark libopenscenegraph-3.2.0~rc1 as breaking simgear: it uses a
    library major version different from the final 3.2.0 series.
    Closes: #722193.

 -- Markus Wanner <markus@bluegap.ch>  Fri, 13 Sep 2013 09:09:55 +0200

=== debian/control ===
Source: flightgear
Section: games
Priority: extra
Maintainer: Debian FlightGear Crew <pkg-fgfs-crew@lists.alioth.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
 Markus Wanner <markus@bluegap.ch>
Build-Depends: debhelper (>= 9.20120417), libx11-dev, libxext-dev,
 libxi-dev, libice-dev, libsm-dev, libxt-dev, libxmu-dev, zlib1g-dev,
 libboost-dev, libopenal-dev, libalut-dev, imagemagick,
 libplib-dev (>= 1.8.5), cmake (>= 2.6),
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 freeglut3-dev | libglut3-dev,
 libjpeg8-dev | libjpeg62-dev | libjpeg-dev,
 libpng12-dev | libpng3-dev | libpng-dev,
 libopenscenegraph-dev (>> 3.0.0),
 libsimgear-dev (>= 3.0.0), libsimgear-dev (<= 3.0.99),
 libsqlite3-dev,
 libudev-dev [linux-any],
 libusbhid-dev [kfreebsd-any],
 libdbus-1-dev,libgsm1-dev,libspeex-dev
Standards-Version: 3.9.5
Homepage: http://www.flightgear.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/flightgear.git
Vcs-Git: git://anonscm.debian.org/collab-maint/flightgear.git

Package: flightgear
Architecture: any
Depends: flightgear-data-all (>= 3.0.0), ${shlibs:Depends},
 ${misc:Depends}
Description: Flight Gear Flight Simulator
 FlightGear Flight Simulator (often shortened to FlightGear or FGFS)
 is a sophisticated free, completely open-source flight simulator
 framework, created by volunteers.
 .
 This package contains the runtime binaries.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#http://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE="RelWithDebInfo" \
	-DCMAKE_C_FLAGS="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-g -DNDEBUG" \
	-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_INSTALL_BINDIR:PATH=games \
	-DFG_DATA_DIR:PATH=/usr/share/games/flightgear \
	-DFGCOM_DATA_PATH=/usr/share/games/flightgear \
	-DSIMGEAR_SHARED:BOOL=ON \
	-DJPEG_FACTORY=ON \
	-DENABLE_FGADMIN=OFF \
	-DENABLE_LARCSIM=ON \
	-DENABLE_UIUC_MODEL=ON \
	-DSP_FDMS=ON \
	-DSYSTEM_SQLITE=ON

%:
	dh $@ --buildsystem=cmake --builddirectory=build --parallel

override_dh_auto_configure:
	mkdir build
	cd build && cmake .. $(CMAKE_FLAGS)

override_dh_auto_build:
	dh_auto_build
	convert -monitor $(CURDIR)/icons/32x32/apps/flightgear.png $(CURDIR)/icons/flightgear.xpm
	convert -monitor $(CURDIR)/icons/32x32/apps/fgcom.png $(CURDIR)/icons/fgcom.xpm

override_dh_auto_install:
	dh_auto_install

#	The CMAKE_INSTALL_BINDIR is ignored
	if [ -d debian/flightgear/usr/bin ]; then \
	  mkdir -p debian/flightgear/usr/games; \
	  mv debian/flightgear/usr/bin/* debian/flightgear/usr/games/; \
	fi

#	Remove empty directories
	find $(CURDIR)/debian/flightgear -type d -empty -delete

override_dh_installdocs:
	dh_installdocs
	cp docs-mini/* debian/flightgear/usr/share/doc/flightgear || true
	cp utils/TerraSync/README.txt debian/flightgear/usr/share/doc/flightgear/README.TerraSync
	rm $(CURDIR)/debian/flightgear/usr/share/doc/flightgear/README.Cygwin
	rm $(CURDIR)/debian/flightgear/usr/share/doc/flightgear/README.IRIX
	rm $(CURDIR)/debian/flightgear/usr/share/doc/flightgear/README.MacOS

#	Drop README.Linux, it's outdated to the point of uselessness.
	rm $(CURDIR)/debian/flightgear/usr/share/doc/flightgear/README.Linux

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_auto_clean:
	rm -f icons/flightgear.xpm icons/fgcom.xpm
	dh_auto_clean

copyright_check:
	${MAKE} -f /usr/share/cdbs/1/rules/utils.mk debian/stamp-copyright-check
	rm debian/stamp-copyright-check

get-orig-source:
	uscan --download-current-version --verbose --rename

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/ \
 ftp://mirrors.ibiblio.org/pub/mirrors/flightgear/ftp/Source/flightgear-(.*)\.tar\.bz2
